{{- $architecture := or .architecture "arm64" -}}
{{- $image := or .image "ubuntu-touch-pinephone-unified.img" -}}
{{- $variant := or .variant "mainline" -}}
{{- $debug := or .debug "on" -}}
{{- $cdimagesmirror := or .cdimagesmirror "http://cdimage.ubuntu.com" -}}
{{- $additional_apt_repos := or .additional_apt_repos "" -}}
{{- $phablet_password := or .phablet_password "1234" }}
{{- $additional_apt_packages := or .additional_apt_packages "eg25-manager" -}}

architecture: {{ $architecture }}
actions:
  - action: recipe
    description: Build pine base
    recipe: pine64-common-focal.yaml
    variables:
      architecture: {{ $architecture }}
      cdimagesmirror: {{ $cdimagesmirror }}
      skip_remove_apt_user: true
      additional_apt_repos: {{ $additional_apt_repos }}
      additional_apt_packages: {{ $additional_apt_packages }}

# PHASE 3: build image
  - action: image-partition
    description: Creating image
    imagename: {{ $image }}
    imagesize: 4GB
    partitiontype: gpt
    mountpoints:
      - mountpoint: /
        partition: root
      - mountpoint: /boot
        partition: boot
    partitions:
      - name: boot
        fs: ext4
        start: 1M
        end: 400MB
        parttype: C12A7328-F81F-11D2-BA4B-00A0C93EC93B
        flags: [ esp,boot ]
      - name: root
        fs: ext4
        start: 400MB
        end: 100%
        parttype: B921B045-1DF0-41C3-AF44-4C6F280D3FAE

  - action: filesystem-deploy
    description: Deploying filesystem into image

  - action: run
    chroot: true
    command: update-initramfs -u

  - action: run
    chroot: true
    description: Make sure EXTLINUX is valid
    script: scripts/zzz-u-boot-pinepro

# these guys need to be run at the very end so they don't break anything else
  - action: overlay
    description: Add post inst script for future kernels
    source: files/last-pine
    destination: /etc/kernel/postinst.d

  # polish.yaml must be run as the last step, as it contains the
  # step to (re-)create /etc/writable symlinks and systemd-nspawn
  # tends to overwrite them.
  - action: recipe
    description: Run common image polishing steps
    recipe: ./polish.yaml
    variables:
      architecture: {{ $architecture }}
      image: {{ $image }}
      output_type: image
